//Copyright (C)2014-2024 Gowin Semiconductor Corporation.
//All rights reserved.
//File Title: IP file
//Tool Version: V1.9.9.01 (64-bit)
//Part Number: GW5A-LV25MG121NC1/I0
//Device: GW5A-25
//Device Version: A
//Created Time: Wed Mar  6 16:44:14 2024

module Gowin_MIPI_DPHY_TX_Top (clkout0, clkout1, clkout2, clkout3, clkout4, tx_clk_o, di_lprx0_n, di_lprx0_p, di_lprx1_n, di_lprx1_p, di_lprx2_n, di_lprx2_p, di_lprx3_n, di_lprx3_p, di_lprxck_n, di_lprxck_p, ck_n, ck_p, d0_n, d0_p, d1_n, d1_p, d2_n, d2_p, d3_n, d3_p, clkin, hstxen_ln0, hstxen_ln1, hstxen_ln2, hstxen_ln3, hstxen_lnck, lptxen_ln0, lptxen_ln1, lptxen_ln2, lptxen_ln3, lptxen_lnck, txdpen_ln0, txdpen_ln1, txdpen_ln2, txdpen_ln3, txdpen_lnck, txhclk_en, ckln_hstxd, d0ln_hstxd, d1ln_hstxd, d2ln_hstxd, d3ln_hstxd, hstxd_vld, do_lptx0_n, do_lptx1_n, do_lptx2_n, do_lptx3_n, do_lptxck_n, do_lptx0_p, do_lptx1_p, do_lptx2_p, do_lptx3_p, do_lptxck_p, lprx_en_ck, lprx_en_d0, lprx_en_d1, lprx_en_d2, lprx_en_d3, tx_drst_n);

output clkout0;
output clkout1;
output clkout2;
output clkout3;
output clkout4;
output tx_clk_o;
output di_lprx0_n;
output di_lprx0_p;
output di_lprx1_n;
output di_lprx1_p;
output di_lprx2_n;
output di_lprx2_p;
output di_lprx3_n;
output di_lprx3_p;
output di_lprxck_n;
output di_lprxck_p;
inout ck_n;
inout ck_p;
inout d0_n;
inout d0_p;
inout d1_n;
inout d1_p;
inout d2_n;
inout d2_p;
inout d3_n;
inout d3_p;
input clkin;
input hstxen_ln0;
input hstxen_ln1;
input hstxen_ln2;
input hstxen_ln3;
input hstxen_lnck;
input lptxen_ln0;
input lptxen_ln1;
input lptxen_ln2;
input lptxen_ln3;
input lptxen_lnck;
input txdpen_ln0;
input txdpen_ln1;
input txdpen_ln2;
input txdpen_ln3;
input txdpen_lnck;
input txhclk_en;
input [7:0] ckln_hstxd;
input [7:0] d0ln_hstxd;
input [7:0] d1ln_hstxd;
input [7:0] d2ln_hstxd;
input [7:0] d3ln_hstxd;
input hstxd_vld;
input do_lptx0_n;
input do_lptx1_n;
input do_lptx2_n;
input do_lptx3_n;
input do_lptxck_n;
input do_lptx0_p;
input do_lptx1_p;
input do_lptx2_p;
input do_lptx3_p;
input do_lptxck_p;
input lprx_en_ck;
input lprx_en_d0;
input lprx_en_d1;
input lprx_en_d2;
input lprx_en_d3;
input tx_drst_n;

wire lock;
wire clkout5;
wire clkout6;
wire clkfbout;
wire [7:0] mdrdo;
wire rx_clk_o;
wire tx_clk_o_o;
wire clkout0;
wire clkout1;
wire clkout2;
wire clkout3;
wire walign_dvld;
wire [15:0] d0ln_hsrxd;
wire [15:0] d1ln_hsrxd;
wire [15:0] d2ln_hsrxd;
wire [15:0] d3ln_hsrxd;
wire d0ln_hsrxd_vld;
wire d1ln_hsrxd_vld;
wire d2ln_hsrxd_vld;
wire d3ln_hsrxd_vld;
wire [7:0] mrdata;
wire alpedo_lane0;
wire alpedo_lane1;
wire alpedo_lane2;
wire alpedo_lane3;
wire alpedo_laneck;
wire d0ln_deskew_done;
wire d1ln_deskew_done;
wire d2ln_deskew_done;
wire d3ln_deskew_done;
wire d0ln_deskew_error;
wire d1ln_deskew_error;
wire d2ln_deskew_error;
wire d3ln_deskew_error;
wire gw_vcc;
wire gw_gnd;

assign walign_dvld = d0ln_deskew_done & d1ln_deskew_done & d2ln_deskew_done & d3ln_deskew_done;
assign tx_clk_o = tx_clk_o_o;
assign gw_vcc = 1'b1;
assign gw_gnd = 1'b0;

PLLA PLLA_inst (
    .LOCK(lock),
    .CLKOUT0(clkout0),
    .CLKOUT1(clkout1),
    .CLKOUT2(clkout2),
    .CLKOUT3(clkout3),
    .CLKOUT4(clkout4),
    .CLKOUT5(clkout5),
    .CLKOUT6(clkout6),
    .CLKFBOUT(clkfbout),
    .MDRDO(mdrdo),
    .CLKIN(clkin),
    .CLKFB(gw_gnd),
    .RESET(gw_gnd),
    .PLLPWD(gw_gnd),
    .RESET_I(gw_gnd),
    .RESET_O(gw_gnd),
    .PSSEL({gw_gnd,gw_gnd,gw_gnd}),
    .PSDIR(gw_gnd),
    .PSPULSE(gw_gnd),
    .SSCPOL(gw_gnd),
    .SSCON(gw_gnd),
    .SSCMDSEL({gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd}),
    .SSCMDSEL_FRAC({gw_gnd,gw_gnd,gw_gnd}),
    .MDCLK(gw_gnd),
    .MDOPC({gw_gnd,gw_gnd}),
    .MDAINC(gw_gnd),
    .MDWDI({gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd})
);

defparam PLLA_inst.FCLKIN = "50";
defparam PLLA_inst.IDIV_SEL = 1;
defparam PLLA_inst.FBDIV_SEL = 1;
defparam PLLA_inst.ODIV0_SEL = 1;
defparam PLLA_inst.ODIV1_SEL = 1;
defparam PLLA_inst.ODIV2_SEL = 1;
defparam PLLA_inst.ODIV3_SEL = 1;
defparam PLLA_inst.ODIV4_SEL = 6;
defparam PLLA_inst.ODIV5_SEL = 8;
defparam PLLA_inst.ODIV6_SEL = 8;
defparam PLLA_inst.MDIV_SEL = 17;
defparam PLLA_inst.MDIV_FRAC_SEL = 0;
defparam PLLA_inst.ODIV0_FRAC_SEL = 0;
defparam PLLA_inst.CLKOUT0_EN = "TRUE";
defparam PLLA_inst.CLKOUT1_EN = "TRUE";
defparam PLLA_inst.CLKOUT2_EN = "TRUE";
defparam PLLA_inst.CLKOUT3_EN = "TRUE";
defparam PLLA_inst.CLKOUT4_EN = "TRUE";
defparam PLLA_inst.CLKOUT5_EN = "FALSE";
defparam PLLA_inst.CLKOUT6_EN = "FALSE";
defparam PLLA_inst.CLKFB_SEL = "INTERNAL";
defparam PLLA_inst.CLKOUT0_DT_DIR = 1'b1;
defparam PLLA_inst.CLKOUT1_DT_DIR = 1'b1;
defparam PLLA_inst.CLKOUT2_DT_DIR = 1'b1;
defparam PLLA_inst.CLKOUT3_DT_DIR = 1'b1;
defparam PLLA_inst.CLKOUT0_DT_STEP = 0;
defparam PLLA_inst.CLKOUT1_DT_STEP = 0;
defparam PLLA_inst.CLKOUT2_DT_STEP = 0;
defparam PLLA_inst.CLKOUT3_DT_STEP = 0;
defparam PLLA_inst.CLK0_IN_SEL = 1'b0;
defparam PLLA_inst.CLK0_OUT_SEL = 1'b0;
defparam PLLA_inst.CLK1_IN_SEL = 1'b0;
defparam PLLA_inst.CLK1_OUT_SEL = 1'b0;
defparam PLLA_inst.CLK2_IN_SEL = 1'b0;
defparam PLLA_inst.CLK2_OUT_SEL = 1'b0;
defparam PLLA_inst.CLK3_IN_SEL = 1'b0;
defparam PLLA_inst.CLK3_OUT_SEL = 1'b0;
defparam PLLA_inst.CLK4_IN_SEL = 2'b00;
defparam PLLA_inst.CLK4_OUT_SEL = 1'b0;
defparam PLLA_inst.CLK5_IN_SEL = 1'b0;
defparam PLLA_inst.CLK5_OUT_SEL = 1'b0;
defparam PLLA_inst.CLK6_IN_SEL = 1'b0;
defparam PLLA_inst.CLK6_OUT_SEL = 1'b0;
defparam PLLA_inst.DYN_DPA_EN = "FALSE";
defparam PLLA_inst.CLKOUT0_PE_COARSE = 0;
defparam PLLA_inst.CLKOUT0_PE_FINE = 0;
defparam PLLA_inst.CLKOUT1_PE_COARSE = 0;
defparam PLLA_inst.CLKOUT1_PE_FINE = 2;
defparam PLLA_inst.CLKOUT2_PE_COARSE = 0;
defparam PLLA_inst.CLKOUT2_PE_FINE = 4;
defparam PLLA_inst.CLKOUT3_PE_COARSE = 0;
defparam PLLA_inst.CLKOUT3_PE_FINE = 6;
defparam PLLA_inst.CLKOUT4_PE_COARSE = 0;
defparam PLLA_inst.CLKOUT4_PE_FINE = 0;
defparam PLLA_inst.CLKOUT5_PE_COARSE = 0;
defparam PLLA_inst.CLKOUT5_PE_FINE = 0;
defparam PLLA_inst.CLKOUT6_PE_COARSE = 0;
defparam PLLA_inst.CLKOUT6_PE_FINE = 0;
defparam PLLA_inst.DYN_PE0_SEL = "FALSE";
defparam PLLA_inst.DYN_PE1_SEL = "FALSE";
defparam PLLA_inst.DYN_PE2_SEL = "FALSE";
defparam PLLA_inst.DYN_PE3_SEL = "FALSE";
defparam PLLA_inst.DYN_PE4_SEL = "FALSE";
defparam PLLA_inst.DYN_PE5_SEL = "FALSE";
defparam PLLA_inst.DYN_PE6_SEL = "FALSE";
defparam PLLA_inst.DE0_EN = "FALSE";
defparam PLLA_inst.DE1_EN = "FALSE";
defparam PLLA_inst.DE2_EN = "FALSE";
defparam PLLA_inst.DE3_EN = "FALSE";
defparam PLLA_inst.DE4_EN = "FALSE";
defparam PLLA_inst.DE5_EN = "FALSE";
defparam PLLA_inst.DE6_EN = "FALSE";
defparam PLLA_inst.RESET_I_EN = "FALSE";
defparam PLLA_inst.RESET_O_EN = "FALSE";
defparam PLLA_inst.ICP_SEL = 6'bXXXXXX;
defparam PLLA_inst.LPF_RES = 3'bXXX;
defparam PLLA_inst.LPF_CAP = 2'b00;
defparam PLLA_inst.SSC_EN = "FALSE";

MIPI_DPHY mipi_dphy_inst (
    .RX_CLK_O(rx_clk_o),
    .TX_CLK_O(tx_clk_o_o),
    .D0LN_HSRXD(d0ln_hsrxd),
    .D1LN_HSRXD(d1ln_hsrxd),
    .D2LN_HSRXD(d2ln_hsrxd),
    .D3LN_HSRXD(d3ln_hsrxd),
    .D0LN_HSRXD_VLD(d0ln_hsrxd_vld),
    .D1LN_HSRXD_VLD(d1ln_hsrxd_vld),
    .D2LN_HSRXD_VLD(d2ln_hsrxd_vld),
    .D3LN_HSRXD_VLD(d3ln_hsrxd_vld),
    .DI_LPRX0_N(di_lprx0_n),
    .DI_LPRX0_P(di_lprx0_p),
    .DI_LPRX1_N(di_lprx1_n),
    .DI_LPRX1_P(di_lprx1_p),
    .DI_LPRX2_N(di_lprx2_n),
    .DI_LPRX2_P(di_lprx2_p),
    .DI_LPRX3_N(di_lprx3_n),
    .DI_LPRX3_P(di_lprx3_p),
    .DI_LPRXCK_N(di_lprxck_n),
    .DI_LPRXCK_P(di_lprxck_p),
    .MRDATA(mrdata),
    .ALPEDO_LANE0(alpedo_lane0),
    .ALPEDO_LANE1(alpedo_lane1),
    .ALPEDO_LANE2(alpedo_lane2),
    .ALPEDO_LANE3(alpedo_lane3),
    .ALPEDO_LANECK(alpedo_laneck),
    .D0LN_DESKEW_DONE(d0ln_deskew_done),
    .D1LN_DESKEW_DONE(d1ln_deskew_done),
    .D2LN_DESKEW_DONE(d2ln_deskew_done),
    .D3LN_DESKEW_DONE(d3ln_deskew_done),
    .D0LN_DESKEW_ERROR(d0ln_deskew_error),
    .D1LN_DESKEW_ERROR(d1ln_deskew_error),
    .D2LN_DESKEW_ERROR(d2ln_deskew_error),
    .D3LN_DESKEW_ERROR(d3ln_deskew_error),
    .CK_N(ck_n),
    .CK_P(ck_p),
    .D0_N(d0_n),
    .D0_P(d0_p),
    .D1_N(d1_n),
    .D1_P(d1_p),
    .D2_N(d2_n),
    .D2_P(d2_p),
    .D3_N(d3_n),
    .D3_P(d3_p),
    .HSRX_STOP(gw_gnd),
    .HSTXEN_LN0(hstxen_ln0),
    .HSTXEN_LN1(hstxen_ln1),
    .HSTXEN_LN2(hstxen_ln2),
    .HSTXEN_LN3(hstxen_ln3),
    .HSTXEN_LNCK(hstxen_lnck),
    .LPTXEN_LN0(lptxen_ln0),
    .LPTXEN_LN1(lptxen_ln1),
    .LPTXEN_LN2(lptxen_ln2),
    .LPTXEN_LN3(lptxen_ln3),
    .LPTXEN_LNCK(lptxen_lnck),
    .PWRON_RX(gw_vcc),
    .PWRON_TX(gw_vcc),
    .RESET(gw_gnd),
    .RX_CLK_1X(rx_clk_o),
    .TX_CLK_1X(tx_clk_o_o),
    .TXDPEN_LN0(txdpen_ln0),
    .TXDPEN_LN1(txdpen_ln1),
    .TXDPEN_LN2(txdpen_ln2),
    .TXDPEN_LN3(txdpen_ln3),
    .TXDPEN_LNCK(txdpen_lnck),
    .TXHCLK_EN(txhclk_en),
    .CKLN_HSTXD({gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,ckln_hstxd[7:0]}),
    .D0LN_HSTXD({gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,d0ln_hstxd[7:0]}),
    .D1LN_HSTXD({gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,d1ln_hstxd[7:0]}),
    .D2LN_HSTXD({gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,d2ln_hstxd[7:0]}),
    .D3LN_HSTXD({gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,gw_vcc,d3ln_hstxd[7:0]}),
    .HSTXD_VLD(hstxd_vld),
    .CK0(clkout0),
    .CK90(clkout1),
    .CK180(clkout2),
    .CK270(clkout3),
    .DO_LPTX0_N(do_lptx0_n),
    .DO_LPTX1_N(do_lptx1_n),
    .DO_LPTX2_N(do_lptx2_n),
    .DO_LPTX3_N(do_lptx3_n),
    .DO_LPTXCK_N(do_lptxck_n),
    .DO_LPTX0_P(do_lptx0_p),
    .DO_LPTX1_P(do_lptx1_p),
    .DO_LPTX2_P(do_lptx2_p),
    .DO_LPTX3_P(do_lptx3_p),
    .DO_LPTXCK_P(do_lptxck_p),
    .HSRX_EN_CK(gw_gnd),
    .HSRX_EN_D0(gw_gnd),
    .HSRX_EN_D1(gw_gnd),
    .HSRX_EN_D2(gw_gnd),
    .HSRX_EN_D3(gw_gnd),
    .HSRX_ODTEN_CK(gw_gnd),
    .HSRX_ODTEN_D0(gw_gnd),
    .HSRX_ODTEN_D1(gw_gnd),
    .HSRX_ODTEN_D2(gw_gnd),
    .HSRX_ODTEN_D3(gw_gnd),
    .LPRX_EN_CK(lprx_en_ck),
    .LPRX_EN_D0(lprx_en_d0),
    .LPRX_EN_D1(lprx_en_d1),
    .LPRX_EN_D2(lprx_en_d2),
    .LPRX_EN_D3(lprx_en_d3),
    .RX_DRST_N(gw_gnd),
    .TX_DRST_N(tx_drst_n),
    .WALIGN_DVLD(walign_dvld),
    .MA_INC(gw_gnd),
    .MCLK(gw_gnd),
    .MOPCODE({gw_gnd,gw_gnd}),
    .MWDATA({gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd,gw_gnd}),
    .D0LN_DESKEW_REQ(gw_gnd),
    .D1LN_DESKEW_REQ(gw_gnd),
    .D2LN_DESKEW_REQ(gw_gnd),
    .D3LN_DESKEW_REQ(gw_gnd),
    .HSRX_DLYDIR_LANE0(gw_gnd),
    .HSRX_DLYDIR_LANE1(gw_gnd),
    .HSRX_DLYDIR_LANE2(gw_gnd),
    .HSRX_DLYDIR_LANE3(gw_gnd),
    .HSRX_DLYDIR_LANECK(gw_gnd),
    .HSRX_DLYLDN_LANE0(gw_gnd),
    .HSRX_DLYLDN_LANE1(gw_gnd),
    .HSRX_DLYLDN_LANE2(gw_gnd),
    .HSRX_DLYLDN_LANE3(gw_gnd),
    .HSRX_DLYLDN_LANECK(gw_gnd),
    .HSRX_DLYMV_LANE0(gw_gnd),
    .HSRX_DLYMV_LANE1(gw_gnd),
    .HSRX_DLYMV_LANE2(gw_gnd),
    .HSRX_DLYMV_LANE3(gw_gnd),
    .HSRX_DLYMV_LANECK(gw_gnd),
    .ALP_EDEN_LANE0(gw_gnd),
    .ALP_EDEN_LANE1(gw_gnd),
    .ALP_EDEN_LANE2(gw_gnd),
    .ALP_EDEN_LANE3(gw_gnd),
    .ALP_EDEN_LANECK(gw_gnd),
    .ALPEN_LN0(gw_gnd),
    .ALPEN_LN1(gw_gnd),
    .ALPEN_LN2(gw_gnd),
    .ALPEN_LN3(gw_gnd),
    .ALPEN_LNCK(gw_gnd),
    .D0LN_HSRX_DREN(gw_gnd),
    .D1LN_HSRX_DREN(gw_gnd),
    .D2LN_HSRX_DREN(gw_gnd),
    .D3LN_HSRX_DREN(gw_gnd)
);

defparam mipi_dphy_inst.TX_PLLCLK = "FAST";
defparam mipi_dphy_inst.TX_HS_8BIT_MODE = 1'b1;
defparam mipi_dphy_inst.HSREG_EN_LN0 = 1'b1;
defparam mipi_dphy_inst.HSREG_EN_LN1 = 1'b1;
defparam mipi_dphy_inst.HSREG_EN_LN2 = 1'b1;
defparam mipi_dphy_inst.HSREG_EN_LN3 = 1'b1;
defparam mipi_dphy_inst.HSREG_EN_LNCK = 1'b1;
defparam mipi_dphy_inst.LANE_DIV_SEL = 2'b01;
defparam mipi_dphy_inst.HSRX_LANESEL = 4'b1111;
defparam mipi_dphy_inst.HSRX_LANESEL_CK = 1'b1;
defparam mipi_dphy_inst.HSTX_EN_LN0 = 1'b1;
defparam mipi_dphy_inst.HSTX_EN_LN1 = 1'b1;
defparam mipi_dphy_inst.HSTX_EN_LN2 = 1'b1;
defparam mipi_dphy_inst.HSTX_EN_LN3 = 1'b1;
defparam mipi_dphy_inst.HSTX_EN_LNCK = 1'b1;
defparam mipi_dphy_inst.LPTX_EN_LN0 = 1'b1;
defparam mipi_dphy_inst.LPTX_EN_LN1 = 1'b1;
defparam mipi_dphy_inst.LPTX_EN_LN2 = 1'b1;
defparam mipi_dphy_inst.LPTX_EN_LN3 = 1'b1;
defparam mipi_dphy_inst.LPTX_EN_LNCK = 1'b1;
defparam mipi_dphy_inst.TXDP_EN_LN0 = 1'b1;
defparam mipi_dphy_inst.TXDP_EN_LN1 = 1'b1;
defparam mipi_dphy_inst.TXDP_EN_LN2 = 1'b1;
defparam mipi_dphy_inst.TXDP_EN_LN3 = 1'b1;
defparam mipi_dphy_inst.TXDP_EN_LNCK = 1'b1;
defparam mipi_dphy_inst.HSREG_VREF_CTL = 3'b100;
defparam mipi_dphy_inst.HSREG_VREF_EN = 1'b1;

endmodule //Gowin_MIPI_DPHY_TX_Top
