//MIPI_DPHY for GW5A-25
module MIPI_DPHY ( ALPEDO_LANE0, ALPEDO_LANE1, ALPEDO_LANE2, ALPEDO_LANE3, ALPEDO_LANECK,  RX_CLK_O, TX_CLK_O, D0LN_DESKEW_DONE, D0LN_DESKEW_ERROR, D0LN_HSRXD, D0LN_HSRXD_VLD, D1LN_DESKEW_DONE, D1LN_DESKEW_ERROR, D1LN_HSRXD, D1LN_HSRXD_VLD, D2LN_DESKEW_DONE, D2LN_DESKEW_ERROR, D2LN_HSRXD, D2LN_HSRXD_VLD, D3LN_DESKEW_DONE, D3LN_DESKEW_ERROR, D3LN_HSRXD, D3LN_HSRXD_VLD, DI_LPRX0_N, DI_LPRX0_P, DI_LPRX1_N, DI_LPRX1_P, DI_LPRX2_N, DI_LPRX2_P, DI_LPRX3_N, DI_LPRX3_P, DI_LPRXCK_N, DI_LPRXCK_P, MRDATA, CK_N, CK_P, D0_N, D0_P, D1_N, D1_P, D2_N, D2_P, D3_N, D3_P, ALP_EDEN_LANE0, ALP_EDEN_LANE1, ALP_EDEN_LANE2, ALP_EDEN_LANE3, ALP_EDEN_LANECK, ALPEN_LN0, ALPEN_LN1, ALPEN_LN2, ALPEN_LN3, ALPEN_LNCK, HSRX_STOP, HSTXEN_LN0, HSTXEN_LN1, HSTXEN_LN2, HSTXEN_LN3, HSTXEN_LNCK, LPTXEN_LN0, LPTXEN_LN1, LPTXEN_LN2, LPTXEN_LN3, LPTXEN_LNCK, PWRON_RX, PWRON_TX, RESET, RX_CLK_1X, TX_CLK_1X, TXDPEN_LN0, TXDPEN_LN1, TXDPEN_LN2, TXDPEN_LN3, TXDPEN_LNCK, TXHCLK_EN, CKLN_HSTXD, D0LN_DESKEW_REQ, D0LN_HSRX_DREN, D0LN_HSTXD, D1LN_DESKEW_REQ, D1LN_HSRX_DREN, D1LN_HSTXD, D2LN_DESKEW_REQ, D2LN_HSRX_DREN, D2LN_HSTXD, D3LN_DESKEW_REQ, D3LN_HSRX_DREN, D3LN_HSTXD,HSTXD_VLD, DO_LPTX0_N, DO_LPTX1_N, DO_LPTX2_N, DO_LPTX3_N,  DO_LPTXCK_N, DO_LPTX0_P, DO_LPTX1_P,  DO_LPTX2_P, DO_LPTX3_P, DO_LPTXCK_P, HSRX_DLYDIR_LANE0, HSRX_DLYDIR_LANE1, HSRX_DLYDIR_LANE2, HSRX_DLYDIR_LANE3, HSRX_DLYDIR_LANECK, HSRX_DLYLDN_LANE0, HSRX_DLYLDN_LANE1, HSRX_DLYLDN_LANE2, HSRX_DLYLDN_LANE3, HSRX_DLYLDN_LANECK, HSRX_DLYMV_LANE0, HSRX_DLYMV_LANE1, HSRX_DLYMV_LANE2, HSRX_DLYMV_LANE3, HSRX_DLYMV_LANECK, HSRX_EN_CK, HSRX_EN_D0, HSRX_EN_D1, HSRX_EN_D2, HSRX_EN_D3, HSRX_ODTEN_CK, HSRX_ODTEN_D0, HSRX_ODTEN_D1, HSRX_ODTEN_D2, HSRX_ODTEN_D3, LPRX_EN_CK, LPRX_EN_D0, LPRX_EN_D1, LPRX_EN_D2, LPRX_EN_D3, MA_INC, MCLK, MOPCODE, MWDATA, RX_DRST_N, TX_DRST_N, WALIGN_DVLD, CK0, CK90, CK180, CK270);

output  ALPEDO_LANE0, ALPEDO_LANE1, ALPEDO_LANE2, ALPEDO_LANE3, ALPEDO_LANECK,
     RX_CLK_O, TX_CLK_O, D0LN_DESKEW_DONE, D0LN_DESKEW_ERROR;
output [15:0] D0LN_HSRXD, D1LN_HSRXD, D2LN_HSRXD, D3LN_HSRXD;//data lane HS data output to fabric
output D0LN_HSRXD_VLD,D1LN_HSRXD_VLD,D2LN_HSRXD_VLD,D3LN_HSRXD_VLD;//data lane HS data output valid to fabric
output D1LN_DESKEW_DONE,D2LN_DESKEW_DONE,D3LN_DESKEW_DONE;
output D1LN_DESKEW_ERROR, D2LN_DESKEW_ERROR, D3LN_DESKEW_ERROR, DI_LPRX0_N, DI_LPRX0_P, DI_LPRX1_N, DI_LPRX1_P, DI_LPRX2_N,  DI_LPRX2_P, DI_LPRX3_N, DI_LPRX3_P, DI_LPRXCK_N, DI_LPRXCK_P;
output [7:0] MRDATA;

inout  CK_N, CK_P, D0_N, D0_P, D1_N, D1_P, D2_N, D2_P, D3_N, D3_P;

input  ALP_EDEN_LANE0, ALP_EDEN_LANE1, ALP_EDEN_LANE2, ALP_EDEN_LANE3,
     ALP_EDEN_LANECK, ALPEN_LN0, ALPEN_LN1, ALPEN_LN2, ALPEN_LN3, ALPEN_LNCK,
     HSRX_STOP, HSTXEN_LN0, HSTXEN_LN1, HSTXEN_LN2, HSTXEN_LN3, HSTXEN_LNCK,
     LPTXEN_LN0, LPTXEN_LN1, LPTXEN_LN2, LPTXEN_LN3, LPTXEN_LNCK, PWRON_RX,
     PWRON_TX, RESET, RX_CLK_1X, TX_CLK_1X, TXDPEN_LN0, TXDPEN_LN1, TXDPEN_LN2,
     TXDPEN_LN3, TXDPEN_LNCK, TXHCLK_EN;
input [15:0]  CKLN_HSTXD,D0LN_HSTXD,D1LN_HSTXD,D2LN_HSTXD,D3LN_HSTXD;
input HSTXD_VLD;

input D0LN_DESKEW_REQ, D0LN_HSRX_DREN, D1LN_DESKEW_REQ, D1LN_HSRX_DREN,
     D2LN_DESKEW_REQ, D2LN_HSRX_DREN,  D3LN_DESKEW_REQ, D3LN_HSRX_DREN;

input DO_LPTX0_N, DO_LPTX1_N, DO_LPTX2_N, DO_LPTX3_N, DO_LPTXCK_N,
     DO_LPTX0_P, DO_LPTX1_P, DO_LPTX2_P, DO_LPTX3_P, DO_LPTXCK_P,
     HSRX_DLYDIR_LANE0, HSRX_DLYDIR_LANE1, HSRX_DLYDIR_LANE2,
     HSRX_DLYDIR_LANE3, HSRX_DLYDIR_LANECK, HSRX_DLYLDN_LANE0,HSRX_DLYLDN_LANE1,
     HSRX_DLYLDN_LANE2, HSRX_DLYLDN_LANE3, HSRX_DLYLDN_LANECK, HSRX_DLYMV_LANE0,
     HSRX_DLYMV_LANE1,  HSRX_DLYMV_LANE2, HSRX_DLYMV_LANE3, HSRX_DLYMV_LANECK,
     HSRX_EN_CK, HSRX_EN_D0, HSRX_EN_D1, HSRX_EN_D2, HSRX_EN_D3, HSRX_ODTEN_CK,
     HSRX_ODTEN_D0, HSRX_ODTEN_D1, HSRX_ODTEN_D2, HSRX_ODTEN_D3, LPRX_EN_CK,
     LPRX_EN_D0, LPRX_EN_D1, LPRX_EN_D2, LPRX_EN_D3, MA_INC, MCLK;
input [1:0] MOPCODE;
input [7:0] MWDATA;
input RX_DRST_N, TX_DRST_N, WALIGN_DVLD;
input CK0, CK90, CK180, CK270; // from pll_lb clkout_0/1/2/3

  parameter        TX_PLLCLK                      = "NONE";
  parameter        CKLN_DELAY_EN                  = 1'b0;
  parameter [6:0]  CKLN_DELAY_OVR_VAL             = 7'b0000000;
  parameter        D0LN_DELAY_EN                  = 1'b0;
  parameter [6:0]  D0LN_DELAY_OVR_VAL             = 7'b0000000;
  parameter        D0LN_DESKEW_BYPASS             = 1'b0;
  parameter        D1LN_DELAY_EN                  = 1'b0;
  parameter [6:0]  D1LN_DELAY_OVR_VAL             = 7'b0000000;
  parameter        D1LN_DESKEW_BYPASS             = 1'b0;
  parameter        D2LN_DELAY_EN                  = 1'b0;
  parameter [6:0]  D2LN_DELAY_OVR_VAL             = 7'b0000000;
  parameter        D2LN_DESKEW_BYPASS             = 1'b0;
  parameter        D3LN_DELAY_EN                  = 1'b0;
  parameter [6:0]  D3LN_DELAY_OVR_VAL             = 7'b0000000;
  parameter        D3LN_DESKEW_BYPASS             = 1'b0;
  parameter        DESKEW_EN_LOW_DELAY            = 1'b0;
  parameter        DESKEW_EN_ONE_EDGE             = 1'b0;
  parameter [3:0]  DESKEW_FAST_LOOP_TIME          = 4'b0000;
  parameter        DESKEW_FAST_MODE               = 1'b0;
  parameter [5:0]  DESKEW_HALF_OPENING            = 6'd22;
  parameter [1:0]  DESKEW_LSB_MODE                = 2'b00;
  parameter [2:0]  DESKEW_M                       = 3'd3;
  parameter [12:0] DESKEW_M_TH                    = 13'd422;
  parameter [6:0]  DESKEW_MAX_SETTING             = 7'd33;
  parameter        DESKEW_ONE_CLK_EDGE_EN         = 1'b0 ;
  parameter        DESKEW_RST_BYPASS              = 1'b0 ;
  parameter [7:0]  RX_ALIGN_BYTE                  = 8'b10111000;
  parameter        RX_BYTE_LITTLE_ENDIAN          = 1'b1 ;
  parameter        RX_CLK_1X_SYNC_SEL             = 1'b0 ;
  parameter        RX_HS_8BIT_MODE                = 1'b0 ;
  parameter        RX_INVERT                      = 1'b0 ;
  parameter        RX_LANE_ALIGN_EN               = 1'b0 ;
  parameter        RX_ONE_BYTE0_MATCH             = 1'b0 ;
  parameter [4:0]  RX_RD_START_DEPTH              = 5'd1;
  parameter        RX_SYNC_MODE                   = 1'b0 ;
  parameter        RX_WORD_ALIGN_BYPASS           = 1'b0 ;
  parameter        RX_WORD_ALIGN_DATA_VLD_SRC_SEL = 1'b0 ;
  parameter        RX_WORD_LITTLE_ENDIAN          = 1'b1 ;
  parameter        TX_BYPASS_MODE                 = 1'b0 ;
  parameter        TX_BYTECLK_SYNC_MODE           = 1'b0 ;
  parameter        TX_HS_8BIT_MODE                = 1'b0 ;
  parameter        TX_OCLK_USE_CIBCLK             = 1'b0 ;
  parameter [4:0]  TX_RD_START_DEPTH              = 5'd1;
  parameter        TX_SYNC_MODE                   = 1'b0 ;
  parameter        TX_WORD_LITTLE_ENDIAN          = 1'b1 ;
  parameter [2:0]  EQ_CS_LANE0                    = 3'b100;
  parameter [2:0]  EQ_CS_LANE1                    = 3'b100;
  parameter [2:0]  EQ_CS_LANE2                    = 3'b100;
  parameter [2:0]  EQ_CS_LANE3                    = 3'b100;
  parameter [2:0]  EQ_CS_LANECK                   = 3'b100;
  parameter [2:0]  EQ_RS_LANE0                    = 3'b100;
  parameter [2:0]  EQ_RS_LANE1                    = 3'b100;
  parameter [2:0]  EQ_RS_LANE2                    = 3'b100;
  parameter [2:0]  EQ_RS_LANE3                    = 3'b100;
  parameter [2:0]  EQ_RS_LANECK                   = 3'b100;
  parameter        HSCLK_LANE_LN0                 = 1'b0;
  parameter        HSCLK_LANE_LN1                 = 1'b0;
  parameter        HSCLK_LANE_LN2                 = 1'b0;
  parameter        HSCLK_LANE_LN3                 = 1'b0;
  parameter        HSCLK_LANE_LNCK                = 1'b1;
  parameter        HSREG_EN_LN0                   = 1'b0;
  parameter        HSREG_EN_LN1                   = 1'b0;
  parameter        HSREG_EN_LN2                   = 1'b0;
  parameter        HSREG_EN_LN3                   = 1'b0;
  parameter        HSREG_EN_LNCK                  = 1'b0;
  parameter [1:0]  LANE_DIV_SEL                   = 2'b0;
  parameter        ALP_ED_EN_LANE0                = 1'b1 ;
  parameter        ALP_ED_EN_LANE1                = 1'b1 ;
  parameter        ALP_ED_EN_LANE2                = 1'b1 ;
  parameter        ALP_ED_EN_LANE3                = 1'b1 ;
  parameter        ALP_ED_EN_LANECK               = 1'b1 ;
  parameter        ALP_ED_TST_LANE0               = 1'b0 ;
  parameter        ALP_ED_TST_LANE1               = 1'b0 ;
  parameter        ALP_ED_TST_LANE2               = 1'b0 ;
  parameter        ALP_ED_TST_LANE3               = 1'b0 ;
  parameter        ALP_ED_TST_LANECK              = 1'b0 ;
  parameter        ALP_EN_LN0                     = 1'b0 ;
  parameter        ALP_EN_LN1                     = 1'b0 ;
  parameter        ALP_EN_LN2                     = 1'b0 ;
  parameter        ALP_EN_LN3                     = 1'b0 ;
  parameter        ALP_EN_LNCK                    = 1'b0 ;
  parameter        ALP_HYS_EN_LANE0               = 1'b1 ;
  parameter        ALP_HYS_EN_LANE1               = 1'b1 ;
  parameter        ALP_HYS_EN_LANE2               = 1'b1 ;
  parameter        ALP_HYS_EN_LANE3               = 1'b1 ;
  parameter        ALP_HYS_EN_LANECK              = 1'b1 ;
  parameter [3:0]  ALP_TH_LANE0                   = 4'b1000 ;
  parameter [3:0]  ALP_TH_LANE1                   = 4'b1000 ;
  parameter [3:0]  ALP_TH_LANE2                   = 4'b1000 ;
  parameter [3:0]  ALP_TH_LANE3                   = 4'b1000 ;
  parameter [3:0]  ALP_TH_LANECK                  = 4'b1000 ;
  parameter [1:0]  ANA_BYTECLK_PH                 = 2'b00 ;
  parameter        BIT_REVERSE_LN0                = 1'b0 ;
  parameter        BIT_REVERSE_LN1                = 1'b0 ;
  parameter        BIT_REVERSE_LN2                = 1'b0 ;
  parameter        BIT_REVERSE_LN3                = 1'b0 ;
  parameter        BIT_REVERSE_LNCK               = 1'b0 ;
  parameter        BYPASS_TXHCLKEN                = 1'b1 ;
  parameter        BYPASS_TXHCLKEN_SYNC           = 1'b0 ;
  parameter        BYTE_CLK_POLAR                 = 1'b0 ;
  parameter        BYTE_REVERSE_LN0               = 1'b0 ;
  parameter        BYTE_REVERSE_LN1               = 1'b0 ;
  parameter        BYTE_REVERSE_LN2               = 1'b0 ;
  parameter        BYTE_REVERSE_LN3               = 1'b0 ;
  parameter        BYTE_REVERSE_LNCK              = 1'b0 ;
  parameter        EN_CLKB1X                      = 1'b1 ;
  parameter [3:0]  EQ_PBIAS_LANE0                 = 4'b1000 ;
  parameter [3:0]  EQ_PBIAS_LANE1                 = 4'b1000 ;
  parameter [3:0]  EQ_PBIAS_LANE2                 = 4'b1000 ;
  parameter [3:0]  EQ_PBIAS_LANE3                 = 4'b1000 ;
  parameter [3:0]  EQ_PBIAS_LANECK                = 4'b1000 ;
  parameter [3:0]  EQ_ZLD_LANE0                   = 4'b1000 ;
  parameter [3:0]  EQ_ZLD_LANE1                   = 4'b1000 ;
  parameter [3:0]  EQ_ZLD_LANE2                   = 4'b1000 ;
  parameter [3:0]  EQ_ZLD_LANE3                   = 4'b1000 ;
  parameter [3:0]  EQ_ZLD_LANECK                  = 4'b1000 ;
  parameter        HIGH_BW_LANE0                  = 1'b1 ;
  parameter        HIGH_BW_LANE1                  = 1'b1 ;
  parameter        HIGH_BW_LANE2                  = 1'b1 ;
  parameter        HIGH_BW_LANE3                  = 1'b1 ;
  parameter        HIGH_BW_LANECK                 = 1'b1 ;
  parameter [2:0]  HSREG_VREF_CTL                 = 3'b100 ;
  parameter        HSREG_VREF_EN                  = 1'b1 ;
  parameter [6:0]  HSRX_DLY_CTL_CK                = 7'b0000000 ;
  parameter [6:0]  HSRX_DLY_CTL_LANE0             = 7'b0000000 ;
  parameter [6:0]  HSRX_DLY_CTL_LANE1             = 7'b0000000 ;
  parameter [6:0]  HSRX_DLY_CTL_LANE2             = 7'b0000000 ;
  parameter [6:0]  HSRX_DLY_CTL_LANE3             = 7'b0000000 ;
  parameter        HSRX_DLY_SEL_LANE0             = 1'b0 ;
  parameter        HSRX_DLY_SEL_LANE1             = 1'b0 ;
  parameter        HSRX_DLY_SEL_LANE2             = 1'b0 ;
  parameter        HSRX_DLY_SEL_LANE3             = 1'b0 ;
  parameter        HSRX_DLY_SEL_LANECK            = 1'b0 ;
  parameter [3:0]  HSRX_DUTY_LANE0                = 4'b1000 ;
  parameter [3:0]  HSRX_DUTY_LANE1                = 4'b1000 ;
  parameter [3:0]  HSRX_DUTY_LANE2                = 4'b1000 ;
  parameter [3:0]  HSRX_DUTY_LANE3                = 4'b1000 ;
  parameter [3:0]  HSRX_DUTY_LANECK               = 4'b1000 ;
  parameter        HSRX_EN                        = 1'b1 ;
  parameter        HSRX_EQ_EN_LANE0               = 1'b1 ;
  parameter        HSRX_EQ_EN_LANE1               = 1'b1 ;
  parameter        HSRX_EQ_EN_LANE2               = 1'b1 ;
  parameter        HSRX_EQ_EN_LANE3               = 1'b1 ;
  parameter        HSRX_EQ_EN_LANECK              = 1'b1 ;
  parameter [3:0]  HSRX_IBIAS                     = 4'b0011 ;
  parameter        HSRX_IBIAS_TEST_EN             = 1'b0 ;
  parameter        HSRX_IMARG_EN                  = 1'b0 ;
  parameter [3:0]  HSRX_LANESEL                   = 4'b1111 ;
  parameter        HSRX_LANESEL_CK                = 1'b1 ;
  parameter        HSRX_ODT_EN                    = 1'b1 ;
  parameter [3:0]  HSRX_ODT_TST                   = 4'b0000 ;
  parameter        HSRX_ODT_TST_CK                = 1'b0 ;
  parameter [3:0]  HSRX_SEL                       = 4'b0000 ;
  parameter        HSRX_STOP_EN                   = 1'b0 ;
  parameter [3:0]  HSRX_TST                       = 4'b0000 ;
  parameter        HSRX_TST_CK                    = 1'b0 ;
  parameter        HSRX_WAIT4EDGE                 = 1'b1 ;
  parameter        HSTX_EN_LN0                    = 1'b0 ;
  parameter        HSTX_EN_LN1                    = 1'b0 ;
  parameter        HSTX_EN_LN2                    = 1'b0 ;
  parameter        HSTX_EN_LN3                    = 1'b0 ;
  parameter        HSTX_EN_LNCK                   = 1'b0 ;
  parameter [1:0]  HYST_NCTL                      = 2'b01 ;
  parameter [1:0]  HYST_PCTL                      = 2'b01 ;
  parameter        IBIAS_TEST_EN                  = 1'b0 ;
  parameter        LB_CH_SEL                      = 1'b0 ;
  parameter        LB_EN_LN0                      = 1'b0 ;
  parameter        LB_EN_LN1                      = 1'b0 ;
  parameter        LB_EN_LN2                      = 1'b0 ;
  parameter        LB_EN_LN3                      = 1'b0 ;
  parameter        LB_EN_LNCK                     = 1'b0 ;
  parameter        LB_POLAR_LN0                   = 1'b0 ;
  parameter        LB_POLAR_LN1                   = 1'b0 ;
  parameter        LB_POLAR_LN2                   = 1'b0 ;
  parameter        LB_POLAR_LN3                   = 1'b0 ;
  parameter        LB_POLAR_LNCK                  = 1'b0 ;
  parameter        LOW_LPRX_VTH                   = 1'b0 ;
  parameter [3:0]  LPBK_DATA2TO1                  = 4'b0000;
  parameter        LPBK_DATA2TO1_CK               = 1'b0 ;
  parameter        LPBK_EN                        = 1'b0 ;
  parameter [3:0]  LPBK_SEL                       = 4'b0000;
  parameter [3:0]  LPBKTST_EN                     = 4'b0000;
  parameter        LPBKTST_EN_CK                  = 1'b0 ;
  parameter        LPRX_EN                        = 1'b1 ;
  parameter [3:0]  LPRX_TST                       = 4'b0000;
  parameter        LPRX_TST_CK                    = 1'b0 ;
  parameter        LPTX_DAT_POLAR_LN0             = 1'b0 ;
  parameter        LPTX_DAT_POLAR_LN1             = 1'b0 ;
  parameter        LPTX_DAT_POLAR_LN2             = 1'b0 ;
  parameter        LPTX_DAT_POLAR_LN3             = 1'b0 ;
  parameter        LPTX_DAT_POLAR_LNCK            = 1'b0 ;
  parameter        LPTX_EN_LN0                    = 1'b1 ;
  parameter        LPTX_EN_LN1                    = 1'b1 ;
  parameter        LPTX_EN_LN2                    = 1'b1 ;
  parameter        LPTX_EN_LN3                    = 1'b1 ;
  parameter        LPTX_EN_LNCK                   = 1'b1 ;
  parameter [2:0]  LPTX_NIMP_LN0                  = 3'b100 ;
  parameter [2:0]  LPTX_NIMP_LN1                  = 3'b100 ;
  parameter [2:0]  LPTX_NIMP_LN2                  = 3'b100 ;
  parameter [2:0]  LPTX_NIMP_LN3                  = 3'b100 ;
  parameter [2:0]  LPTX_NIMP_LNCK                 = 3'b100 ;
  parameter [2:0]  LPTX_PIMP_LN0                  = 3'b100 ;
  parameter [2:0]  LPTX_PIMP_LN1                  = 3'b100 ;
  parameter [2:0]  LPTX_PIMP_LN2                  = 3'b100 ;
  parameter [2:0]  LPTX_PIMP_LN3                  = 3'b100 ;
  parameter [2:0]  LPTX_PIMP_LNCK                 = 3'b100 ;
  parameter        MIPI_PMA_DIS_N                 = 1'b1 ;
  parameter [3:0]  PGA_BIAS_LANE0                 = 4'b1000 ;
  parameter [3:0]  PGA_BIAS_LANE1                 = 4'b1000 ;
  parameter [3:0]  PGA_BIAS_LANE2                 = 4'b1000 ;
  parameter [3:0]  PGA_BIAS_LANE3                 = 4'b1000 ;
  parameter [3:0]  PGA_BIAS_LANECK                = 4'b1000 ;
  parameter [3:0]  PGA_GAIN_LANE0                 = 4'b1000 ;
  parameter [3:0]  PGA_GAIN_LANE1                 = 4'b1000 ;
  parameter [3:0]  PGA_GAIN_LANE2                 = 4'b1000 ;
  parameter [3:0]  PGA_GAIN_LANE3                 = 4'b1000 ;
  parameter [3:0]  PGA_GAIN_LANECK                = 4'b1000 ;
  parameter [3:0]  RX_ODT_TRIM_LANE0              = 4'b1000 ;
  parameter [3:0]  RX_ODT_TRIM_LANE1              = 4'b1000 ;
  parameter [3:0]  RX_ODT_TRIM_LANE2              = 4'b1000 ;
  parameter [3:0]  RX_ODT_TRIM_LANE3              = 4'b1000 ;
  parameter [3:0]  RX_ODT_TRIM_LANECK             = 4'b1000 ;
  parameter [3:0]  SLEWN_CTL_LN0                  = 4'b1111 ;
  parameter [3:0]  SLEWN_CTL_LN1                  = 4'b1111 ;
  parameter [3:0]  SLEWN_CTL_LN2                  = 4'b1111 ;
  parameter [3:0]  SLEWN_CTL_LN3                  = 4'b1111 ;
  parameter [3:0]  SLEWN_CTL_LNCK                 = 4'b1111 ;
  parameter [3:0]  SLEWP_CTL_LN0                  = 4'b1111 ;
  parameter [3:0]  SLEWP_CTL_LN1                  = 4'b1111 ;
  parameter [3:0]  SLEWP_CTL_LN2                  = 4'b1111 ;
  parameter [3:0]  SLEWP_CTL_LN3                  = 4'b1111 ;
  parameter [3:0]  SLEWP_CTL_LNCK                 = 4'b1111 ;
  parameter [1:0]  STP_UNIT                       = 2'b01 ;
  parameter [3:0]  TERMN_CTL_LN0                  = 4'b1000 ;
  parameter [3:0]  TERMN_CTL_LN1                  = 4'b1000 ;
  parameter [3:0]  TERMN_CTL_LN2                  = 4'b1000 ;
  parameter [3:0]  TERMN_CTL_LN3                  = 4'b1000 ;
  parameter [3:0]  TERMN_CTL_LNCK                 = 4'b1000 ;
  parameter [3:0]  TERMP_CTL_LN0                  = 4'b1000 ;
  parameter [3:0]  TERMP_CTL_LN1                  = 4'b1000 ;
  parameter [3:0]  TERMP_CTL_LN2                  = 4'b1000 ;
  parameter [3:0]  TERMP_CTL_LN3                  = 4'b1000 ;
  parameter [3:0]  TERMP_CTL_LNCK                 = 4'b1000 ;
  parameter        TEST_EN_LN0                    = 1'b0 ;
  parameter        TEST_EN_LN1                    = 1'b0 ;
  parameter        TEST_EN_LN2                    = 1'b0 ;
  parameter        TEST_EN_LN3                    = 1'b0 ;
  parameter        TEST_EN_LNCK                   = 1'b0 ;
  parameter        TEST_N_IMP_LN0                 = 1'b0 ;
  parameter        TEST_N_IMP_LN1                 = 1'b0 ;
  parameter        TEST_N_IMP_LN2                 = 1'b0 ;
  parameter        TEST_N_IMP_LN3                 = 1'b0 ;
  parameter        TEST_N_IMP_LNCK                = 1'b0 ;
  parameter        TEST_P_IMP_LN0                 = 1'b0 ;
  parameter        TEST_P_IMP_LN1                 = 1'b0 ;
  parameter        TEST_P_IMP_LN2                 = 1'b0 ;
  parameter        TEST_P_IMP_LN3                 = 1'b0 ;
  parameter        TEST_P_IMP_LNCK                = 1'b0 ;
  parameter        TXDP_EN_LN0                    = 1'b0 ;
  parameter        TXDP_EN_LN1                    = 1'b0 ;
  parameter        TXDP_EN_LN2                    = 1'b0 ;
  parameter        TXDP_EN_LN3                    = 1'b0 ;
  parameter        TXDP_EN_LNCK                   = 1'b0 ;

  supply1 vcc;
  supply0 vss;

  reg GSRN;
  initial begin
    GSRN=0;
    #0;
    GSRN=1;
  end

  //mipi_top
  gw5a25_TqJp9UEYwaNIke1BYUxJew pm(
    ALPEDO_LANE0, ALPEDO_LANE1, ALPEDO_LANE2, ALPEDO_LANE3, ALPEDO_LANECK, NC_1, NC_2, NC_3, NC_4, RX_CLK_O, TX_CLK_O,
    D0LN_DESKEW_DONE, D0LN_DESKEW_ERROR, D0LN_HSRXD, D0LN_HSRXD_VLD, D1LN_DESKEW_DONE, D1LN_DESKEW_ERROR, D1LN_HSRXD,
    D1LN_HSRXD_VLD, D2LN_DESKEW_DONE, D2LN_DESKEW_ERROR, D2LN_HSRXD, D2LN_HSRXD_VLD, D3LN_DESKEW_DONE,
    D3LN_DESKEW_ERROR, D3LN_HSRXD, D3LN_HSRXD_VLD, DI_LPRX0_N, DI_LPRX0_P, DI_LPRX1_N, DI_LPRX1_P, DI_LPRX2_N,
    DI_LPRX2_P, DI_LPRX3_N, DI_LPRX3_P, DI_LPRXCK_N, DI_LPRXCK_P, NC_5, NC_6, MRDATA, NC_7, CK_N, CK_P, D0_N, D0_P,
    D1_N, D1_P, D2_N, D2_P, D3_N, D3_P, vcc, vcc, vcc, vcc, vcc, vss, 8'b0, 1'b0, 1'b0, 2'b0, GSRN, ALP_EDEN_LANE0,
    ALP_EDEN_LANE1, ALP_EDEN_LANE2, ALP_EDEN_LANE3, ALP_EDEN_LANECK, ALPEN_LN0, ALPEN_LN1, ALPEN_LN2, ALPEN_LN3,
    ALPEN_LNCK, HSRX_STOP, HSTXEN_LN0, HSTXEN_LN1, HSTXEN_LN2, HSTXEN_LN3, HSTXEN_LNCK, LPTXEN_LN0, LPTXEN_LN1,
    LPTXEN_LN2, LPTXEN_LN3, LPTXEN_LNCK, PWRON_RX, PWRON_TX, RESET, RX_CLK_1X, TX_CLK_1X, TXDPEN_LN0, TXDPEN_LN1,
    TXDPEN_LN2, TXDPEN_LN3, TXDPEN_LNCK, TXHCLK_EN, CK0, CK90, CK180, CK270, CKLN_HSTXD, vss, D0LN_DESKEW_REQ,
    D0LN_HSRX_DREN, D0LN_HSTXD, vss, D1LN_DESKEW_REQ, D1LN_HSRX_DREN, D1LN_HSTXD, vss, D2LN_DESKEW_REQ, D2LN_HSRX_DREN,
    D2LN_HSTXD, vss, D3LN_DESKEW_REQ, D3LN_HSRX_DREN, D3LN_HSTXD, HSTXD_VLD, DO_LPTX0_N, DO_LPTX1_N, DO_LPTX2_N,
    DO_LPTX3_N, DO_LPTXCK_N, DO_LPTX0_P, DO_LPTX1_P, DO_LPTX2_P, DO_LPTX3_P, DO_LPTXCK_P, 1'b1, 8'h04, 1'b1, GSRN,
    HSRX_DLYDIR_LANE0, HSRX_DLYDIR_LANE1, HSRX_DLYDIR_LANE2, HSRX_DLYDIR_LANE3, HSRX_DLYDIR_LANECK, HSRX_DLYLDN_LANE0,
    HSRX_DLYLDN_LANE1, HSRX_DLYLDN_LANE2, HSRX_DLYLDN_LANE3, HSRX_DLYLDN_LANECK, HSRX_DLYMV_LANE0, HSRX_DLYMV_LANE1,
    HSRX_DLYMV_LANE2, HSRX_DLYMV_LANE3, HSRX_DLYMV_LANECK, HSRX_EN_CK, HSRX_EN_D0, HSRX_EN_D1, HSRX_EN_D2, HSRX_EN_D3,
    HSRX_ODTEN_CK, HSRX_ODTEN_D0, HSRX_ODTEN_D1, HSRX_ODTEN_D2, HSRX_ODTEN_D3, 1'b0, 2'b0, 1'b0, LPRX_EN_CK, LPRX_EN_D0,
    LPRX_EN_D1, LPRX_EN_D2, LPRX_EN_D3, 1'b1, 1'b0, MA_INC, MCLK, MOPCODE, MWDATA, GSRN, RX_DRST_N, TX_DRST_N,
    WALIGN_DVLD, STP_UNIT, HSRX_WAIT4EDGE, HYST_NCTL, HYST_PCTL, LANE_DIV_SEL, BYPASS_TXHCLKEN, BYPASS_TXHCLKEN_SYNC,
    ALP_ED_EN_LANECK, ALP_ED_TST_LANECK, ALP_HYS_EN_LANECK, ALP_TH_LANECK, RX_RD_START_DEPTH, RX_HS_8BIT_MODE,
    RX_WORD_LITTLE_ENDIAN, RX_BYTE_LITTLE_ENDIAN, RX_ONE_BYTE0_MATCH, RX_WORD_ALIGN_BYPASS, RX_SYNC_MODE,
    RX_CLK_1X_SYNC_SEL, RX_LANE_ALIGN_EN, RX_INVERT, RX_WORD_ALIGN_DATA_VLD_SRC_SEL, RX_ALIGN_BYTE, DESKEW_FAST_MODE,
    DESKEW_EN_LOW_DELAY, DESKEW_EN_ONE_EDGE, DESKEW_ONE_CLK_EDGE_EN, DESKEW_FAST_LOOP_TIME, DESKEW_M_TH, DESKEW_M,
    DESKEW_HALF_OPENING, DESKEW_MAX_SETTING, DESKEW_LSB_MODE, DESKEW_RST_BYPASS, D0LN_DESKEW_BYPASS, D1LN_DESKEW_BYPASS,
    D2LN_DESKEW_BYPASS, D3LN_DESKEW_BYPASS, CKLN_DELAY_EN, CKLN_DELAY_OVR_VAL, D0LN_DELAY_EN, D0LN_DELAY_OVR_VAL,
    D1LN_DELAY_EN, D1LN_DELAY_OVR_VAL, D2LN_DELAY_EN, D2LN_DELAY_OVR_VAL, D3LN_DELAY_EN, D3LN_DELAY_OVR_VAL,
    TX_BYPASS_MODE, TX_HS_8BIT_MODE, TX_SYNC_MODE, TX_RD_START_DEPTH, TX_WORD_LITTLE_ENDIAN, TX_OCLK_USE_CIBCLK,
    TX_BYTECLK_SYNC_MODE, EQ_CS_LANECK, EQ_RS_LANECK, HSRX_EQ_EN_LANECK, HSRX_DUTY_LANECK, HSRX_DLY_CTL_CK,
    HSCLK_LANE_LNCK, HSREG_EN_LNCK, BIT_REVERSE_LNCK, BYTE_REVERSE_LNCK, LPTX_NIMP_LNCK, LPTX_PIMP_LNCK, SLEWN_CTL_LNCK,
    SLEWP_CTL_LNCK, TERMN_CTL_LNCK, TERMP_CTL_LNCK, EQ_CS_LANE0, EQ_RS_LANE0, HSRX_EQ_EN_LANE0, HSRX_DUTY_LANE0,
    HSRX_DLY_CTL_LANE0, HSCLK_LANE_LN0, HSREG_EN_LN0, BIT_REVERSE_LN0, BYTE_REVERSE_LN0, LPTX_NIMP_LN0, LPTX_PIMP_LN0,
    SLEWN_CTL_LN0, SLEWP_CTL_LN0, TERMN_CTL_LN0, TERMP_CTL_LN0, ALP_ED_EN_LANE0, ALP_ED_TST_LANE0, ALP_HYS_EN_LANE0,
    ALP_TH_LANE0, EQ_CS_LANE1, EQ_RS_LANE1, HSRX_EQ_EN_LANE1, HSRX_DUTY_LANE1, HSRX_DLY_CTL_LANE1, HSCLK_LANE_LN1,
    HSREG_EN_LN1, BIT_REVERSE_LN1, BYTE_REVERSE_LN1, LPTX_NIMP_LN1, LPTX_PIMP_LN1, SLEWN_CTL_LN1, SLEWP_CTL_LN1,
    TERMN_CTL_LN1, TERMP_CTL_LN1, ALP_ED_EN_LANE1, ALP_ED_TST_LANE1, ALP_HYS_EN_LANE1, ALP_TH_LANE1, EQ_CS_LANE2,
    EQ_RS_LANE2, HSRX_EQ_EN_LANE2, HSRX_DUTY_LANE2, HSRX_DLY_CTL_LANE2, HSCLK_LANE_LN2, HSREG_EN_LN2, BIT_REVERSE_LN2,
    BYTE_REVERSE_LN2, LPTX_NIMP_LN2, LPTX_PIMP_LN2, SLEWN_CTL_LN2, SLEWP_CTL_LN2, TERMN_CTL_LN2, TERMP_CTL_LN2,
    ALP_ED_EN_LANE2, ALP_ED_TST_LANE2, ALP_HYS_EN_LANE2, ALP_TH_LANE2, EQ_CS_LANE3, EQ_RS_LANE3, HSRX_EQ_EN_LANE3,
    HSRX_DUTY_LANE3, HSRX_DLY_CTL_LANE3, HSCLK_LANE_LN3, HSREG_EN_LN3, BIT_REVERSE_LN3, BYTE_REVERSE_LN3, LPTX_NIMP_LN3,
    LPTX_PIMP_LN3, SLEWN_CTL_LN3, SLEWP_CTL_LN3, TERMN_CTL_LN3, TERMP_CTL_LN3, ALP_ED_EN_LANE3, ALP_ED_TST_LANE3,
    ALP_HYS_EN_LANE3, ALP_TH_LANE3, MIPI_PMA_DIS_N, HSRX_EN, HSRX_ODT_EN, LPRX_EN, LOW_LPRX_VTH, HSRX_LANESEL,
    HSRX_ODT_TST, HSRX_LANESEL_CK, HSRX_ODT_TST_CK, HSRX_STOP_EN, HSRX_IMARG_EN, HSRX_SEL, HSRX_IBIAS,
    HSRX_IBIAS_TEST_EN, BYTE_CLK_POLAR, EN_CLKB1X, ANA_BYTECLK_PH, HSREG_VREF_CTL, HSREG_VREF_EN, HSRX_TST, LPRX_TST,
    IBIAS_TEST_EN, LPBK_EN, LB_CH_SEL, LPBK_DATA2TO1, LPBK_SEL, LPBKTST_EN, LPBK_DATA2TO1_CK, LPBKTST_EN_CK, HSRX_TST_CK,
    LPRX_TST_CK, RX_ODT_TRIM_LANECK, EQ_ZLD_LANECK, PGA_GAIN_LANECK, EQ_PBIAS_LANECK, PGA_BIAS_LANECK, HIGH_BW_LANECK,
    HSRX_DLY_SEL_LANECK, TXDP_EN_LNCK, ALP_EN_LNCK, LPTX_EN_LNCK, HSTX_EN_LNCK, LB_EN_LNCK, LB_POLAR_LNCK,
    LPTX_DAT_POLAR_LNCK, TEST_EN_LNCK, TEST_N_IMP_LNCK, TEST_P_IMP_LNCK, RX_ODT_TRIM_LANE0, EQ_ZLD_LANE0, PGA_GAIN_LANE0,
    EQ_PBIAS_LANE0, PGA_BIAS_LANE0, HIGH_BW_LANE0, HSRX_DLY_SEL_LANE0, TXDP_EN_LN0, ALP_EN_LN0, LPTX_EN_LN0, HSTX_EN_LN0,
    LB_EN_LN0, LB_POLAR_LN0, LPTX_DAT_POLAR_LN0, TEST_EN_LN0, TEST_N_IMP_LN0, TEST_P_IMP_LN0, RX_ODT_TRIM_LANE1,
    EQ_ZLD_LANE1, PGA_GAIN_LANE1, EQ_PBIAS_LANE1, PGA_BIAS_LANE1, HIGH_BW_LANE1, HSRX_DLY_SEL_LANE1, TXDP_EN_LN1,
    ALP_EN_LN1, LPTX_EN_LN1, HSTX_EN_LN1, LB_EN_LN1, LB_POLAR_LN1, LPTX_DAT_POLAR_LN1, TEST_EN_LN1, TEST_N_IMP_LN1,
    TEST_P_IMP_LN1, RX_ODT_TRIM_LANE2, EQ_ZLD_LANE2, PGA_GAIN_LANE2, EQ_PBIAS_LANE2, PGA_BIAS_LANE2, HIGH_BW_LANE2,
    HSRX_DLY_SEL_LANE2, TXDP_EN_LN2, ALP_EN_LN2, LPTX_EN_LN2, HSTX_EN_LN2, LB_EN_LN2, LB_POLAR_LN2, LPTX_DAT_POLAR_LN2,
    TEST_EN_LN2, TEST_N_IMP_LN2, TEST_P_IMP_LN2, RX_ODT_TRIM_LANE3, EQ_ZLD_LANE3, PGA_GAIN_LANE3, EQ_PBIAS_LANE3,
    PGA_BIAS_LANE3, HIGH_BW_LANE3, HSRX_DLY_SEL_LANE3, TXDP_EN_LN3, ALP_EN_LN3, LPTX_EN_LN3, HSTX_EN_LN3, LB_EN_LN3,
    LB_POLAR_LN3, LPTX_DAT_POLAR_LN3, TEST_EN_LN3, TEST_N_IMP_LN3, TEST_P_IMP_LN3);

endmodule
